=== debian/changelog ===
protobuf (3.21.12-8ubuntu1) noble; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't build elpa stuff on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 09 Nov 2023 09:11:26 +0100

protobuf (3.21.12-8) unstable; urgency=medium

  [ Meng Sang <sangmeng@loongson.cn> ]
  * Added 'loong64' to enable specific build options (closes: #1052384).

  [ Matthias Klose <doko@ubuntu.com> ]
  * Fix tests for Python 3.12 (closes: #1055549).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 08 Nov 2023 17:59:09 +0100

protobuf (3.21.12-7ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't build elpa stuff on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 08 Sep 2023 13:47:52 +0200

protobuf (3.21.12-7) unstable; urgency=medium

  [ Aurelien Jarno <aurelien@aurel32.net> ]
  * Python: stop using backward compatibility timezones (closes: #1050937).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 08 Sep 2023 02:21:34 +0000

protobuf (3.21.12-6ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't build elpa stuff on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 06 Jul 2023 10:11:26 +0200

protobuf (3.21.12-6) unstable; urgency=medium

  * Add dependency to libprotobuf-java package (closes: #1040260).
  * Use javahelper architecture independent way.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 04 Jul 2023 18:02:00 +0200

protobuf (3.21.12-5) unstable; urgency=medium

  * Move javahelper to Build-Depends (closes: #1039959).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 01 Jul 2023 08:38:59 +0200

protobuf (3.21.12-4) unstable; urgency=medium

  [ Pierre Gruet <pgt@debian.org> ]
  * Removing the dependency on j2objc in the pom.xml file of protobuf-util.jar
  * Having test scope for junit in the pom.xml file of protobuf-util.jar
  * Building with javahelper to fill in the classpath of the built jar
    (closes: #1039521).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 29 Jun 2023 21:47:51 +0200

protobuf (3.21.12-3ubuntu1) mantic; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't build elpa stuff on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 05 May 2023 10:05:33 +0200

protobuf (3.21.12-3) unstable; urgency=medium

  * Fix build-time tests on 32 bit architectures (closes: #1033998).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 09 Apr 2023 05:50:55 +0000

protobuf (3.21.12-2) unstable; urgency=medium

  [ Helmut Grohne <helmut@subdivi.de> ]
  * Reenable build-time testing (closes: #1033989).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 05 Apr 2023 21:57:20 +0200

protobuf (3.21.12-1ubuntu7) lunar; urgency=medium

  * Rebuild to drop Python 3.10 extension

 -- Jeremy Bicha <jbicha@ubuntu.com>  Tue, 28 Feb 2023 19:23:02 -0500

protobuf (3.21.12-1ubuntu6) lunar; urgency=medium

  * No-change upload to remove support for ruby3.0.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Thu, 02 Feb 2023 14:17:21 -0300

protobuf (3.21.12-1ubuntu5) lunar; urgency=medium

  * No-change upload to add support for ruby3.1.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Mon, 23 Jan 2023 13:06:21 -0300

protobuf (3.21.12-1ubuntu4) lunar; urgency=medium

  * Disable test on i386, fails if elpa is not built.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 03 Jan 2023 22:50:21 +0100

protobuf (3.21.12-1ubuntu1) lunar; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - Don't build elpa stuff on i386

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 27 Dec 2022 14:08:14 +0100

protobuf (3.21.12-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 17 Dec 2022 09:18:06 +0100

protobuf (3.21.11-1) unstable; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sat, 10 Dec 2022 09:53:49 +0100

protobuf (3.21.10-1) unstable; urgency=medium

  * New upstream release.
  * Update Standards-Version to 4.6.1 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 04 Dec 2022 13:49:06 +0100

protobuf (3.21.9-5) unstable; urgency=medium

  * Backport upstream fix of Makefile rule for java target in examples
    (closes: #1024677).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 25 Nov 2022 07:04:22 +0100

protobuf (3.21.9-4) unstable; urgency=medium

  * Don't try to build elpa-protobuf-mode on architectures where dh-elpa is
    not available.
  * Don't check alignment of typename U on hppa.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 22 Nov 2022 19:00:45 +0100

protobuf (3.21.9-3) unstable; urgency=medium

  * Upload to Sid (closes: #993266).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Mon, 21 Nov 2022 20:49:14 +0100

protobuf (3.21.9-2) experimental; urgency=medium

  * Backport upstream fix to build with Python 3.11 (closes: #1023963).

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Sun, 13 Nov 2022 11:14:34 +0100

protobuf (3.21.9-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Tue, 01 Nov 2022 07:09:22 +0100

protobuf (3.21.8-1) experimental; urgency=medium

  * New upstream release.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Fri, 21 Oct 2022 06:18:13 +0200

protobuf (3.21.7-1) experimental; urgency=high

  * New upstream release:
    - fix CVE-2022-3171: potential denial of service in the Java protobuf
      runtime.

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Thu, 06 Oct 2022 21:03:23 +0200

protobuf (3.21.6-1) experimental; urgency=medium

  * New major upstream release (closes: #1018262).
  * Library transition from libproto*31 to libproto*32 .

 -- Laszlo Boszormenyi (GCS) <gcs@debian.org>  Wed, 28 Sep 2022 14:34:55 +0200

protobuf (3.20.2-1) experimental; urgency=high

  * New upstream release:
    - fix CVE-2022-1941: parsing vulnerability for the MessageSet type.


